#define NEW(t,n) ((t*) malloc( sizeof(t) * (n) ))
#define RENEW(o,t,n) ((t*) realloc( (void*) o, sizeof(t) * (n) ))
#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define MIN(a,b) ((a) < (b) ? (a) : (b))


#define SERVER_SOFTWARE "nHTTPD/0.1.0"

#define CNST_FREE 0
#define CNST_READING 1
#define CNST_SENDING 2
#define CNST_SENDEND 3
#define CNST_SLEEP 4

#define STAT_OK 200
#define STAT_BAD 400
#define STAT_NOAUTH 401
#define STAT_FORBIDDEN 403
#define STAT_NOTFOUND 404

#define STATR_200 "OK"
#define STATR_400 "Bad Request"
#define STATR_401 "Unauthorized"
#define STATR_403 "Forbidden"
#define STATR_404 "Not Found"


#define PORT 80

#define LISTEN_BACKLOG 1024

/* α */
#define SERVER_LOGFILE "nhttpd.log"

/*  */
#define SERVER_USER "nobody"


/*   */
#define DOCUMENT_ROOT "/document"

/* pid   */
#define PIDFILE "nhttpd.pid"

/*   ִ Ŭ̾Ʈ */
#define MAXCLIENT 512

/* select Ÿ̸ */
#define SELECT_TV_SEC 0
#define SELECT_TV_USEC 1000

/* hc ⺻  ũ */
#define HC_DEF_BUF 256
#define HC_METHOD_BUF 4	 /* HTTP/1.0  */
#define HC_PROTOCOL_BUF 8
#define HC_FILENAME_BUF 512
#define HC_URL_BUF 1024

/* ⺻/ִ  ũ */
#define RECV_BUF_SIZE 32767
#define RECV_MAX_BUF_SIZE 1048576
#define SEND_BUF_SIZE 32767


/* index  ̸ */
#define INDEXFILE "index.html"

/* ŸӾƿ */
#define TIMEOUT 5
